
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class jump {
    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
    static HashMap<Integer, LinkedList<Integer>> pairs = new HashMap<Integer, LinkedList<Integer>>();
    static TreeSet<Integer> visited = new TreeSet<Integer>();
    static LinkedList<Integer> q = new LinkedList<Integer>();
    static int max;
    static int[] pebbles;
    
    static String nextToken() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(input.readLine());
        return st.nextToken();
    }
    
    static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    
    public static void searchKey(int indexOfExpanded, int key) {
      
        LinkedList<Integer> l = pairs.get(key);
        for (Iterator<Integer> iterator = l.iterator(); iterator.hasNext();) {
            int next = iterator.next();
//            System.out.println("next " + next + " key " + key);
            if ((next <= key && key <= indexOfExpanded) || (next >= key && key >= indexOfExpanded)) {
                //System.out.println("asdasd" + next);
                if (visited.contains(next))
                    continue;
//                System.out.println("sdfsdf" + next);
                q.push(next);
                visited.add(next);
                if (next > max)
                    max = next;
            }
        }
    }
    
    public static void main(String[] args) throws IOException {
        while (true) {
            pairs = new HashMap<Integer, LinkedList<Integer>>();
            visited = new TreeSet<Integer>();
            q = new LinkedList<Integer>();
            int num = nextInt();
            if (num == 0)
                return;
            
            pebbles = new int[num];
            
            for (int i = 0; i < num; i++) {
                int p = nextInt();
                if (p+i < num) {
                    if (pairs.get(p+i) == null)
                        pairs.put(p+i, new LinkedList<Integer>());
                    pairs.get(p+i).push(i);
                }
                if (i-p >= 0) {
                    if (pairs.get(i-p) == null)
                        pairs.put(i-p, new LinkedList<Integer>());
                    pairs.get(i-p).push(i);
                }

                pebbles[i] = p;
            }
            
            q.push(0);
            visited.add(0);
            max = 0;
            while (!q.isEmpty()) {
                int cur = q.pollLast();
                
                visited.add(cur);
//                System.out.println("expanding " + cur + " " + pebbles[cur]);
                if (cur+pebbles[cur] < num)
                    searchKey(cur, cur+pebbles[cur]);
                if (cur-pebbles[cur] >= 0)
                    searchKey(cur, cur-pebbles[cur]);
            }
            System.out.println(max);
        }
    }    
}
